import * as tslib_1 from "tslib";
import { FetchyMiddleware, } from "./base";
var FetchyRavenMiddleware = (function (_super) {
    tslib_1.__extends(FetchyRavenMiddleware, _super);
    function FetchyRavenMiddleware(config, next) {
        var _this = _super.call(this, config, next) || this;
        _this.errorCategory = "fetchy-js_response_captured";
        _this.responseCategory = "fetchy-js_error_captured";
        if (config.categories !== undefined) {
            _this.errorCategory = config.categories.error;
            _this.responseCategory = config.categories.response;
        }
        return _this;
    }
    FetchyRavenMiddleware.prototype.processResponse = function (promise0) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2, promise0
                        .catch(function (e) {
                        if (e.hasErrors()) {
                            e.errors.forEach(function (error) {
                                return _this.captureErrorBreadcrumb(error);
                            });
                        }
                        if (e.hasResponses()) {
                            e.responses.forEach(function (response) {
                                return _this.captureResponseBreadcrumb(response.clone());
                            });
                        }
                        throw e;
                    })];
            });
        });
    };
    FetchyRavenMiddleware.prototype.captureErrorBreadcrumb = function (error) {
        this.config.ravenClient.captureBreadcrumb({
            category: this.errorCategory,
            data: {
                message: error.message,
                name: error.name,
            },
            message: "Failed response",
        });
    };
    FetchyRavenMiddleware.prototype.captureResponseBreadcrumb = function (response) {
        this.config.ravenClient.captureBreadcrumb({
            category: this.responseCategory,
            data: {
                body: response.body,
                status: response.status,
            },
            message: "Error occurred",
        });
    };
    return FetchyRavenMiddleware;
}(FetchyMiddleware));
export { FetchyRavenMiddleware };
//# sourceMappingURL=raven.js.map